// Imagine++ project
// Project:  matrices
// Author:   keriven
// Date:     2007/10/19

#include<iostream>
using namespace std;

// Argument passing
double trace(double A[2][2]) {
    double t=0;
    for(int i=0; i<2; i++)
        t+=A[i][i];
    return t;
}

// Always by variable
void set(double A[2][3]) {
    for(int i=0; i<2; i++)
        for(int j=0; j<3; j++)
            A[i][j]=i+j;
}

void set(double A[],int m,int n) {
    for(int i=0; i<m; i++)
        for(int j=0; j<n; j++)
            A[i+m*j]=i+j;
}

// y=Ax
void product(double A[],int m,int n,double x[],double y[]) {
    for(int i=0; i<m; i++) {
        y[i]=0;
        for(int j=0; j<n; j++)
            y[i]+=A[i+m*j]*x[j];
    }
}

int main()
{
    int A[2][2];
    for(int i=0; i<2; i++)
        for(int j=0; j<2; j++)
            A[i][j]=i+j;
    int B[2][3]={{1,2,3},{4,5,6}};
    const int M=2,N=3;
    double D[2][2]={{1,2},{3,4}};
    double t=trace(D);
    double E[2][3];
    set(E);
    double F[2*3];
    set(F,2,3);
    double G[3*5];
    set(G,3,5);

    double P[2*3],x[3],y[2];
    for(int i=0; i<2; i++)
		for(int j=0; j<3; j++)
			P[i+2*j]=i+j;
	for(int i=0; i<3; i++)
		x[i]=i;
    product(P,2,3,x,y); // y=Px
    return 0;
}
